=== autotests/tools/CMakeLists.txt ===
ecm_add_tests(
    IdentifierTest.cpp
    StaticSetOfStringsTest.cpp

    LINK_LIBRARIES KDb Qt5::Test
)
