## kdb 3.0.2

=== debian/changelog ===
kdb (3.0.2-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.0.1, no changes required.
  * Update symbols file. (Closes: #871182)
  * Small copyright update.

 -- Pino Toscano <pino@debian.org>  Sat, 19 Aug 2017 10:51:33 +0200

kdb (3.0.1.1-1) unstable; urgency=medium

  * New upstream release.
  * Update the patches:
    - upstream_cmake-find-PostgreSQL-9.6.patch: drop, backported from upstream
  * Bump Standards-Version to 4.0.0, no changes required.
  * Add qttools5-dev-tools as new required build dependency.
  * Upload to unstable.

 -- Pino Toscano <pino@debian.org>  Sat, 24 Jun 2017 11:22:14 +0200

kdb (3.0.0-2) experimental; urgency=medium

  * Update symbols file.
  * Add the qtbase5-dev, and libkf5coreaddons-dev dependencies to libkdb3-dev,
    needed to use the kdb headers.

 -- Pino Toscano <pino@debian.org>  Sun, 29 Jan 2017 09:33:39 +0100

kdb (3.0.0-1) experimental; urgency=medium

  * Initial release.

 -- Pino Toscano <pino@debian.org>  Sun, 22 Jan 2017 15:05:21 +0100
