=== debian/rules ===
#!/usr/bin/make -f

export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

%:
	dh $@ --parallel --with kf5

override_dh_auto_configure:
	dh_auto_configure -Skf5 -- -DBUILD_TESTING=OFF

override_dh_auto_install:
	dh_auto_install
	# remove translations of unbuilt drivers
	rm -f debian/tmp/usr/share/locale/*/LC_MESSAGES/kdb_sybasedriver_qt.mo
	rm -f debian/tmp/usr/share/locale/*/LC_MESSAGES/kdb_xbasedriver_qt.mo

override_dh_install:
	dh_install --fail-missing

.PHONY: override_dh_auto_test
