=== debian/watch ===
version=4

http://download.kde.org/stable/kdb/src/kdb-([\d\.]+)\.tar\.xz
