## kdb 3.1.0

=== debian/changelog ===
kdb (3.1.0-3~mx17+1) mx; urgency=medium

  * Repackaged for MX 17.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Sat, 27 Oct 2018 19:59:52 -0700

kdb (3.1.0-3) unstable; urgency=medium

  * Update symbols file from logs of buildds.
  * Bump Standards-Version to 4.1.4, no changes required.

 -- Pino Toscano <pino@debian.org>  Sat, 21 Apr 2018 06:43:28 +0200

kdb (3.1.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Pino Toscano <pino@debian.org>  Fri, 09 Mar 2018 09:28:49 +0100

kdb (3.1.0-1) experimental; urgency=medium

  * New upstream release.
  * Rename libkdb3-3 to libkdb3-4 according to the upstream SONAME bump.
  * Switch the python build dependency to python3, as it is supposed now by
    the build scripts
    - pass -DPython_ADDITIONAL_VERSIONS=3 to cmake, to make FindPythonInterp
      accept Python 3
  * Update symbols file.
  * Simplify watch file, and switch it to https.
  * Bump Standards-Version to 4.1.3, no changes required.
  * Stop removing translations of unbuilt drivers, as they are not shipped
    anymore.
  * Bump the debhelper compatibility to 11:
    - bump the debhelper build dependency to 11~
    - bump compat to 11
    - remove --parallel for dh, as now done by default
  * Switch from dh_install to dh_missing for --fail-missing.
  * Switch Vcs-* fields to salsa.debian.org.
  * Mark also libkdb3-dev as Multi-Arch: same.

 -- Pino Toscano <pino@debian.org>  Thu, 08 Mar 2018 11:21:23 +0100

kdb (3.0.2-2) unstable; urgency=medium

  * Team upload.
  * Change build-dependency from qttools5-dev-tools to qttools5-dev.
    (Closes: #881078)

 -- Dmitry Shachnev <mitya57@debian.org>  Wed, 08 Nov 2017 16:28:38 +0300
