=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: kdb
 Section: libs
 Priority: optional
-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
+Maintainer: Mike Purtell <mmikeinsantarosa@mxlinux.org>
+XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
 Uploaders: Pino Toscano <pino@debian.org>
 Build-Depends: cmake (>= 3.0),
-               debhelper (>= 9),
+               debhelper (>= 11~),
                default-libmysqlclient-dev,
                extra-cmake-modules (>= 1.8.0),
                libicu-dev,
@@ -16,15 +17,15 @@
                pkg-config,
                pkg-kde-tools (>= 0.15.16),
                postgresql-server-dev-all,
-               python,
+               python3,
                qtbase5-dev (>= 5.4.0),
-               qttools5-dev-tools,
-Standards-Version: 4.0.1
+               qttools5-dev,
+Standards-Version: 4.1.4
 Homepage: https://community.kde.org/KDb
-Vcs-Git: https://anonscm.debian.org/git/pkg-kde/calligra/kdb.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-kde/calligra/kdb.git
+Vcs-Git: https://salsa.debian.org/qt-kde-team/kde-extras/kdb.git
+Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde-extras/kdb
 
-Package: libkdb3-3
+Package: libkdb3-4
 Architecture: any
 Multi-Arch: same
 Depends: libkdb-data (>= ${source:Version}),
@@ -55,8 +56,9 @@
 
 Package: libkdb3-dev
 Architecture: any
+Multi-Arch: same
 Section: libdevel
-Depends: libkdb3-3 (= ${binary:Version}),
+Depends: libkdb3-4 (= ${binary:Version}),
          qtbase5-dev (>= 5.4.0),
          libkf5coreaddons-dev (>= 5.16.0),
          ${misc:Depends},
@@ -71,7 +73,7 @@
 
 Package: libkdb3-driver-sqlite
 Architecture: any
-Depends: libkdb3-3 (= ${binary:Version}),
+Depends: libkdb3-4 (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
 Description: SQLite driver for KDb
@@ -86,7 +88,7 @@
 Package: libkdb3-driver-mysql
 Architecture: any
 Multi-Arch: same
-Depends: libkdb3-3 (= ${binary:Version}),
+Depends: libkdb3-4 (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
 Description: MySQL driver for KDb
@@ -101,7 +103,7 @@
 Package: libkdb3-driver-postgresql
 Architecture: any
 Multi-Arch: same
-Depends: libkdb3-3 (= ${binary:Version}),
+Depends: libkdb3-4 (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
 Description: PostgreSQL driver for KDb
